<template>
  <div
    class="page-table scrollable only-y"
    id="affix-container"
  >
    <div class>
      <h1>Blogs</h1>
      <!--<h4>for a better experience on Mac OS during horizontal scroll is prefered disable the "Swipe between pages" option </h4>-->
      <el-breadcrumb separator="/">
        <el-breadcrumb-item :to="{ path: '/' }">
          <i class="mdi mdi-home-outline"></i>
        </el-breadcrumb-item>
        <el-breadcrumb-item>Blog</el-breadcrumb-item>
      </el-breadcrumb>
      <div style="text-align: right; position: relative">
        <el-button
          type="primary"
          style="position: absolute; top: -30px; right: 0"
          class=""
          @click="goCreate"
        >
          <i class="mdi mdi-plus"> </i>
          <span> Add</span>
        </el-button>
      </div>
    </div>
    <br>
    <el-card v-if="not_found">
      <not-found />

    </el-card>
    <el-card
      v-else
      class="box-card"
      style="text-align: left; margin: 20px 0"
      v-loading="loading"
    >
      <div class="card-header">

      </div>
      <el-table
        rowClassName="pointer-row"
        @row-click="showDetail"
        :data="list"
        style="width: 100%"
      >
        <el-table-column
          width="100"
          fixed
          prop="id"
          label="ID"
        >
        </el-table-column>
        <el-table-column
          fixed
          prop="title"
          label="Title"
          width="120"
        >
        </el-table-column>

        <el-table-column
          prop="contents"
          label="Contents"
          min-width="150"
        >
        </el-table-column>
        <el-table-column
          prop="createAt"
          label="Created at"
        >
          <template slot-scope="scope">
            <span>{{scope.row.createAt | moment('DD-MM-YYYY') }}</span>
          </template>
        </el-table-column>
        <el-table-column
          prop="updateAt"
          label="Updated at"
        >
          <template slot-scope="scope">
            <span>{{scope.row.updateAt | moment('DD-MM-YYYY') }}</span>
          </template>
        </el-table-column>
        <el-table-column
          prop="status"
          label="Status"
          min-width="150"
        >
          <template slot-scope="scope">
            <div
              v-if="scope.row.status"
              style=""
            >
              <el-tag
                v-if="scope.row.status == '1'"
                style="min-width: 120px; text-align:center;"
                type="success"
                size="small"
                class="font-weight-500"
              >
                Active
              </el-tag>
              <el-tag
                v-if="scope.row.status == '0'"
                style="min-width: 120px; text-align:center;"
                type="danger"
                size="small"
                class="font-weight-500"
              >
                Inactive
              </el-tag>

            </div>
          </template>
        </el-table-column>

      </el-table>
      <div
        class="flex justify-space-between"
        style="align-items:center;"
      >
        <!-- <span>Total items: {{total}}</span> -->
        <el-pagination
          v-if="total > pageSize"
          class="right"
          background
          layout="prev, pager, next"
          style="margin-top: 20px"
          :current-page="currentPage"
          :page-size="pageSize"
          @current-change="onChangePage"
          :total="total"
        ></el-pagination>
      </div>
    </el-card>

    <!--<div class="search-wrap flex align-center">
                    <div><i class="mdi mdi-magnify"></i></div>
                    <input v-model="search" placeholder="Search a contact" class="box grow"/>
                    <div class="contacts-tot">{{contactsFiltered.length}} contacts</div>
                    <el-button icon="mdi mdi-account-plus" circle @click="openDialog({})"></el-button>
        </div>-->

    <!--<user-dialog :dialogvisible.sync="dialogvisible" :userdata="userdata"></user-dialog>-->

    <!-- <view-image
      :dialogvisible.sync="dialogvisible"
      :imageUrl.sync="imageUrl"
    >
    </view-image> -->
  </div>
</template>

<script>

import { blog as blogAPI } from "~/services/apis/index";
import NotFound from '../ContentNotFound'
export default {
  name: "Blog",
  components: {
    'not-found': NotFound
  },
  data () {
    return {
      search: "",
      disabled: false,
      dialogvisible: false,
      imageUrl: null,
      pageWidth: 0,
      userdata: {},
      contacts: [],
      loading: true,
      currentPage: 1,
      list: [],
      total: 0,
      pageSize: this.$store.state.itemPerPage,
      curID: 0,
      defaultFilter: {},
      sortBy: "",
      dir: "",
      employeeID: '',
      not_found: false,
      verifyValue: "all"
    };
  },
  components: {

  },
  computed: {
    onSubmit () {
      return this.$store.state.searchSubmit;
    }
  },
  watch: {
    onSubmit () {
      this.onSearch()
    },
    '$route.query' () {
      this.initParams();
      this.getListData();
    }
  },
  methods: {
    goCreate () {
      this.$router.push({ name: 'blog_create' })
    },
    openDialog (data) {
      this.userdata = data;
      this.dialogvisible = true;
    },
    setPageWidth () {
      this.pageWidth = document.getElementById("page-contacts").offsetWidth;
    },
    __resizeHanlder: _.throttle(function (e) {
      //this.setPageWidth()
    }, 700),

    getListData () {
      this.loading = true;
      blogAPI
        .getBlogs()
        .then(res => {
          //eslint-disable-next-line
          console.log('res.data.data :', res);
          this.list = res.data.blogList;
          this.loading = false;
          this.total = parseInt(res.headers["x-total-count"]);
        }).catch(error => {
          this.$notify({
            title: "Error",
            message: "Cannot get data from server!",
            type: "error"
          });
          this.loading = false
          this.not_found = true
        })
    },

    initParams () {
      if (!this.$route.query) return;
      this.currentPage = this.$route.query.page
        ? this.$helper.formatPage(this.$route.query.page)
        : 1;
      // this.sortBy = this.$route.query.sort ? this.$route.query.sort : null;
      // this.dir = this.$route.query.dir ? this.$route.query.dir : null;
      this.search = this.$route.query.q ? this.$route.query.q : "";
      this.$store.commit("setSearchValue", this.search);
      this.verifyValue =
        this.$route.query.is_verified == 1 ? this.$route.query.is_verified :
          this.$route.query.is_verified == 0 ? this.$route.query.is_verified
            : "all";
    },
    showDetail (row) {
      var selection = window.getSelection();
      if (selection.toString().length !== 0) return;

      var id = row.id;
      this.$router.push({ name: "blog_detail", params: { id } });
    },


    onChangePage (page) {
      this.currentPage = this.$helper.formatPage(page);
      let sQuery = this.$route.query;
      sQuery.page = this.currentPage;
      this.updateRoute(sQuery);
    },

    updateRoute (query) {
      // console.log('push', query);
      this.$router.replace({ query: { page: 0 } });
      this.$router.replace({ name: "workplaces", query: query });
    },
    changeVerifyFilter (value) {
      if (value == "all") {
        this.verifyValue = "all";
      } else {
        this.verifyValue = value;
      }

      this.currentPage = 1;

      let sQuery = {};
      sQuery.page = this.currentPage;
      sQuery.is_verified = this.verifyValue;
      this.updateRoute(sQuery);
    },
    onSearch () {
      this.search = this.$store.state.search;
      this.currentPage = 1;

      let sQuery = {};
      sQuery.page = this.currentPage;
      sQuery.q = this.search;
      this.updateRoute(sQuery);
      this.$store.commit("setSearchValue", this.search);
    },
    showAvatar (url, event) {
      if (event) {
        event.preventDefault();
        event.stopPropagation();
      }

      if (!url) return;
      this.imageUrl = url;
      this.dialogvisible = true;
    }
  },
  mounted () {
    this.initParams();
    this.getListData();
  }
};
</script>

<style lang="scss" scoped>
@import "../../../assets/scss/_variables";

.img-profile img {
  height: 200px;
  width: 200px;
  border-radius: 10px;
  box-sizing: border-box;
  border: 5px solid #fff;
  box-shadow: 0 7px 20px -7px rgba(0, 0, 0, 0.55);
}

.btn-eye {
  padding: 1px 6px;
}

.page-contacts {
  height: 100%;
  margin: 0 !important;
  padding: 20px;
  padding-bottom: 10px;
  box-sizing: border-box;

  .search-card {
    padding: 50px;
    max-width: 350px;
    max-height: 320px;
    box-sizing: border-box;
    margin-bottom: 15px;

    .el-input,
    .el-button {
      width: 100%;
    }
  }

  .search-wrap {
    margin: 0 auto;
    margin-bottom: 10px;
    padding: 0px 30px;
    box-sizing: border-box;
    width: 100%;
    max-width: 600px;

    i {
      display: inline-block;
      width: 22px;
    }

    input {
      outline: none;
      background: transparent;
      border: none;
      font-size: 15px;
      position: relative;
      top: -2px;
      width: 100%;
      padding: 0;
      color: $text-color;
    }

    .contacts-tot {
      margin-right: 20px;
      margin-left: 10px;
    }

    a {
      border-bottom: 1px solid;
      text-decoration: none;
      color: $text-color;

      &:hover {
        opacity: 0.6;
      }
    }
  }

  .contacts-root {
    max-height: 100%;
  }

  .contacts-list {
    //margin: 0 auto;
    width: 100%;
    max-width: 965px;
    padding: 0px 30px;
    box-sizing: border-box;

    .contact {
      margin: 10px 0;
      padding: 5px;
      box-sizing: border-box;
      cursor: pointer;
      transition: all 0.5s 0.25s;
      border-bottom: 1px solid #00000011;

      .star {
        .mdi-star {
          color: #ffd730;
        }
        .mdi-star-outline {
          opacity: 0.5;
        }
      }

      .avatar {
        width: 60px;
        transition: all 0.5s 0.25s;

        img {
          border: 1px solid transparentize($text-color, 0.9);
          box-sizing: border-box;
          width: 50px;
          height: 50px;
          border-radius: 50%;
          transition: all 0.5s 0.25s;
        }
      }

      .info {
        word-break: break-word;

        .name {
          //.fullname {}

          .email {
            opacity: 0;
            line-height: 0;
            transition: all 0.5s 0.25s;
          }

          .phone {
            display: none;
          }
        }

        //.phone {}
      }

      &:hover {
        margin: 15px -20px;
        padding: 10px;
        background-color: lighten($background-color, 20%);
        border-radius: 5px;
        box-shadow: 0 8px 16px 0 rgba(40, 40, 90, 0.09),
          0 3px 6px 0 rgba(0, 0, 0, 0.065);

        .avatar {
          width: 90px;

          img {
            width: 90px;
            height: 90px;
          }
        }

        .info {
          .name {
            .email {
              opacity: 1;
              line-height: 1.4;
            }
          }
        }
      }
    }
  }

  .contacts-root {
    &.medium {
      .search-card {
        padding: 20px;
        max-width: 260px;
        max-height: 260px;
      }
    }
    &.small {
      overflow-y: auto;
      display: block;
      -webkit-box-orient: vertical;
      -webkit-box-direction: normal;
      -ms-flex-direction: column;
      flex-direction: column;
      padding: 5px;

      .search-card {
        padding: 20px;
        max-width: 100%;
        width: 100%;
        //max-height: 240px;
        flex: none;
        -webkit-box-flex: none;
        -ms-flex: none;
        display: block;
        overflow: hidden !important;
      }

      .contacts-list {
        flex: none;
        -webkit-box-flex: none;
        -ms-flex: none;
        display: block;
        overflow: hidden !important;
      }
    }
  }
}

@media (max-width: 768px) {
  .page-contacts {
    .search-wrap {
      padding: 0;
    }
    .contacts-list {
      padding: 0px;

      .contact {
        .avatar {
          width: 40px;

          img {
            width: 40px;
            height: 40px;
          }
        }

        .info {
          .phone {
            display: none;
          }

          .name {
            .phone {
              display: block;
            }
          }
        }

        &:hover {
          margin: 15px 0px;

          .avatar {
            width: 60px;

            img {
              width: 60px;
              height: 60px;
            }
          }
        }
      }
    }

    .contacts-root {
      &.medium {
        .contacts-list {
          padding: 0 30px;
        }
      }
      &.small {
        .contacts-list {
          padding: 8px;
        }
      }
    }
    .z-999 {
      z-index: 9999;
    }
  }
}
</style>

